; Slightly modified version of Ruud's  "TEST.ASM" screen capture code.
;
; Changes by TAD:
;                - palette buffer used to avoid possible overwrite of following code
;                - checks for INT 16h functions 00h, 01h, 10h and 11h
;                - returns a fake key-press (spacebar) and ZF=0
;                - "One-shot" operation (ie. it disables itself after 1st capture)
;                - creates the raw 64768 file called "ENTRY.RAW" instead of "TEST.RAW"

; Changes : Undone the use of buffer inside the file, (sorry TAD)
;           Int 16h function 1 and 11h don't trigger the grabber,
;           files ENTRYn.RAW are created at each int 16h, ah=0 or 10h,
;           this allows multiple images....

; Changes by TAD:
;		- displays time taken by ENTRY.COM (Mins and Seconds)

; Changed by TAD:
;		- more compact 00:00.00 for time


                 .model    tiny
                 .386
                 
                 .code
begin:           org       100h
start:           mov       sp,(Top-begin+20fh) and 0fff0h
                 mov       bx,(Top-begin+50fh)/16
                           ; The value in BX makes sure we own 300h bytes
                           ; above the SP
                 mov       ah,4ah
                 int       21h                  ;Resize req mem

                 mov       ax,cs
                 mov       wcs1,ax
                 mov       wcs2,ax
                 mov       wcs3,ax
                 mov       ax,3516h
                 int       21h                  ;Get vector 10h
                 mov       word ptr dOrg16,bx
                 mov       word ptr dOrg16+2,es
                 mov       dx,offset cs:int16
                 mov       ax,2516h
                 int       21h                  ;New vector 10h

		mov	ah,0
		int	1Ah			; read system time counter
		mov	wTimeLow,dx
		mov	wTimeHigh,cx

                 mov       dx,offset ds:bFname
                 push      ds
                 pop       es
                 mov       bx,offset ds:xEpb
                 mov       ax,4b00h
                 int       21h                  ;execute entry.com

                 lds       dx,cs:dOrg16
                 mov       ax,2516h
                 int       21h                  ;Restore vector 10h

		push	cs
		pop	ds
		push	cs
		pop	es
		mov	ah,00h
		int	1Ah			; read final time
		xchg	ax,cx
		xchg	ax,dx
		sub	ax,wTimeLow
		sbb	dx,wTimeHigh		; time difference (DX.AX)
		mov	di,444h
		div	di			; minutes
		call	outtime
		mov	word ptr ds:tMins,ax	; Minutes
		mov	al,12h
		xchg	ax,dx
		div	dl
		call	outtime
		mov	word ptr ds:tSecs,ax	; Seconds
		xchg	ax,dx
		call	outtime
		mov	word ptr ds:tms55,ax	; 55ms

		mov	dx,offset ds:tInfo
		mov	ah,9
		int	21h			; display time message

                 mov       ax,4C00h
                 int       21h                  ;Exit error 0

outtime:
	aam
	xchg	ah,al
	or	ax,'00'
	ret

; Modified INT 16h wedge
;                - now checks for functions 01h, 10h and 11h
;                - returns a fake key press and ZF=0
;                - disables after 1st capture.
int16:
                 cmp       ah,0
                 jz        short grab           ; function 00 ?
                 cmp       ah,10h
                 jz        short grab           ; function 10h ?
                 jmp short go16                 ;>> No flat line
grab:
                 pusha
                 push      ds
                 push      es
                 push      cs
                 pop       es
                 push      cs
                 pop       ds
                 mov       dx,(Top-begin+20fh) and 0fff0h
                 xor       bx,bx
                 mov       cx,100h
                 mov       ax,1017h
                 int       10h
                 xor       cx,cx
                 mov       ah,3ch
                 mov       dx,offset bOname
                 int       21h
                 xchg      ax,bx
                 inc       bLastChar            ;Next file name
                 mov       dx,(Top-begin+20fh) and 0fff0h
                 mov       cx,300h
                 mov       ah,40h
                 int       21h
                 mov       dx,0a000h
                 mov       ds,dx
                 xor       dx,dx
                 mov       cx,0fa00h
                 mov       ah,40h
                 int       21h
                 mov       ah,3eh
                 int       21h
                 pop       es
                 pop       ds
                 popa
                 mov       ax,3920h             ; fake key = spacebar
                 iret

go16:            db        0eah                 ;Don't mess with interrupt
dOrg16           dd        ?

wTimeLow	dw	?		;
wTimeHigh	dw	?		; start time 55ms counter

tInfo		db	'Time taken '
tMins		db	'xx:'
tSecs		db	'xx.'
tms55		db	'xx',13,10,'$'

bFname           Db        'ENTRY.COM',0
bOname           Db        'ENTRY'
bLastChar        Db        '0.RAW',0
xEpb             Dw        0                    ;Inherit env
                 Dw        80h
wcs1             Dw        ?
                 Dw        5ch
wcs2             Dw        ?
                 Dw        6ch
wcs3             Dw        ?
                 Dw        $-xEpb


Top              Label     Byte

                 end       start

